import 'package:auto_route/auto_route.dart';
import 'package:cpt_form/modules/detail/form_detail_page.dart';
import 'package:flutter/material.dart';
import 'package:flutter_hooks/flutter_hooks.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:widgets/ext/ex_widget.dart';
import 'package:widgets/load_state_layout.dart';
import 'package:widgets/widget_export.dart';
import 'form_not_approve_view_model.dart';
import 'item_form_not_approve.dart';

@RoutePage()
class FormNotApproveScreen extends HookConsumerWidget {
  @override
  Widget build(BuildContext context, WidgetRef ref) {
    final viewModel = ref.read(formNotApproveViewModelProvider.notifier);
    final state = ref.watch(formNotApproveViewModelProvider);

    useEffect(() {
      // 组件挂载时执行 - 执行接口请求
      Future.microtask(() => viewModel.fetchList());
      return () {
        // 组件卸载时执行
      };
    }, []);

    return SizedBox(
      width: double.infinity,
      height: double.infinity,
      child: EasyRefresh(
        controller: viewModel.refreshController,
        onRefresh: viewModel.onRefresh,
        onLoad: viewModel.loadMore,
        child: LoadStateLayout(
          state: state.loadingState,
          errorMessage: state.errorMessage,
          errorRetry: () {
            viewModel.retryRequest();
          },
          successSliverWidget: [
            SliverList(
                delegate: SliverChildBuilderDelegate(
              (context, index) {
                return FormNotApproveItem(index: index, item: state.datas[index]).onTap(() {
                  //去详情页面
                  //去详情页面
                  FormDetailPage.startInstance(
                    context: context,
                    estateFormId: state.datas[index].estateOnlineFormId ?? "",
                    taskId: state.datas[index].id ?? "",
                    type: state.datas[index].estateOnlineForm?.type?.id ?? "",
                  );
                });
              },
              childCount: state.datas.length,
            )),
          ],
        ),
      ).marginOnly(top: 5, bottom: 5),
    );
  }
}
